require 'kafka_session/message'
require 'forwardable'

class KafkaSession
  class DeliveredMessage
    extend Forwardable

    delegate [:topic, :partition, :offset, :key] => :raw_message
    delegate [:value, :session_id, :published_at] => :message

    attr_reader :message, :raw_message

    def initialize(raw_message)
      @raw_message = raw_message
      @message     = Message.parse(raw_message.value)
    end

    def session
      @session ||= KafkaSession.new(id: message.session_id)
    end
  end
end
