require 'kafka_session/delivered_message'

class KafkaSession
  class MockProducer
    def initialize
      @messages_by_topic = Hash.new { |messages, topic| messages[topic] = [] }
    end

    def publish(topic:, messages:)
      messages.each do |message|
        @messages_by_topic[topic] << OpenStruct.new(
          value:     message,
          topic:     topic,
          partition: 1,
          offset:    100,
          key:       nil
        )
      end
    end

    def messages_for_topic(topic)
      @messages_by_topic[topic].map do |message|
        DeliveredMessage.new(message)
      end
    end
  end
end
