require 'kafka'

class KafkaSession
  class Producer
    attr_reader :client

    def initialize(name:, brokers:)
      @client = Kafka.new(
        seed_brokers: brokers,
        client_id:    name
      )
    end

    def publish(messages:, topic:)
      producer = client.producer

      messages.each do |message|
        producer.produce(message, topic: topic)
      end

      producer.deliver_messages
    end
  end
end
